Subject: Re: [tsvwg] Comments on draft-ietf-tsvwg-ecn-encap-guidelines-13

From: Bob Briscoe <[email-masked]>
Date: Tue, 10 Mar 2020 17:28:42 +0000

Donald,

Thank you for taking the time to review this (rather long) draft.
Apologies for not getting to your review until now.

On 06/02/2020 23:03, Donald Eastlake wrote:
> Hi,
>
> I'm not subscribed to the tsvwg mailing list but I have reviewed 
> draft-ietf-tsvwg-ecn-encap-guidelines-13 and though you might be 
> interested in my comments.
>
> Overall, this is a very clear and well-written draft. The comments 
> below are minor. Whether or not they are incorporated into the draft, 
> I hope that it can be advanced soon.
>
> Section 1. I suggest just deleting the one occurrence in the draft of 
> "[RFC1323]" and the corresponding reference section entry. It seems 
> unnecessary and just leads to a nits checker warning which will have 
> to be explained, etc.
>
> Section 1.1. Very minor but I believe the usual way, inside a draft, 
> to refer to the RFC which that draft might become is "[this document]" 
> (without the double quotes) rather than "[RFCXXXX]". Changing to the 
> more common notation would, I believe, enable the RFC Editor note to 
> be removed as "[this document]" is well understood by the RFC Editor.
>
> Section 2. The initial paragraph on implementation keywords should be 
> updated to the following as per RFC 8174:
>
>     The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT",
>     "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this
>     document are to be interpreted as described in [RFC2119] [RFC8174]
>     when, and only when, they appear in all capitals, as shown here.
>
Done all the above
(BTW, I always baulk at having to cite RFC8174, when the following 12 
words succinctly state the sum total of its content.)

>
> Section 2. Suggest putting the Terminology entries in alphabetic order..
I haven't done this. They are more for reading through than for being 
looked up individually, most of them fall into logical little groups, 
and there are not so many that it's hard to find one.

>
> Section 4.2, page 18. "802.1p" has been merged into 802.1Q ages ago. 
> Values of the priority field are commonly referred to in IEEE 802.1 as 
> Priority Code Points (PCPs) and in any case this seems a bit 
> inconsistent to the way that the merger of 802.1ah into 802.1Q is 
> recognized in the draft. Perhaps the last sentence of Section 4.2 
> could be: "An operator can define certain [IEEE802.1Q] Priority Code 
> Points to indicate non-QCN frames and an ingress bridge is required to 
> map arriving not-QCN-capable IP packets to one of these code points."
OK. I've taken on board the spirit of your edit, but changed it slightly:

    An operator can define certain
    Priority Code Points (PCPs [IEEE802.1Q]; previously 802.1p) to
    indicate non-QCN frames and an ingress bridge is required to map
    arriving not-QCN-capable IP packets to one of these non-QCN PCPs.

This is then consistent with the other references to 802.1Q, which also 
give the number of the constituent part before it was wrapped up into 
the mega-standard. If you think this is clumsy, pls say. I did it this 
way, because many people know these 802.1 drafts much better by their 
old name (well, for 'many people' read 'me', or perhaps read it as 'old 
farts like me').

>
> Section 4.4, point 1, first starred subpoint, there is something odd 
> about "the packet MAY be forwarded, but it SHOULD be dropped".
Any better (I've added some of the context for the list)?:

           If the congestion marking is the
           most severe possible, the packet MUST be dropped.  However, if
           congestion can be marked with multiple levels of severity and
           the packet's marking is not the most severe, this requirement
           can be relaxed to: the packet SHOULD be dropped, but it MAY be
           forwarded.

>
> Section 7. It doesn't matter much but IANA would prefer that sections 
> saying there are no IANA actions be left in the final RFC (see Section 
> 9.1 of RFC 8126).
I'm learning something new every day.

>
> Section 9. Should "the document" in the first line of this section by 
> "this document"?
Yes. Done.
>
> Appendix A. I did not review this update history.
>
> Authors' Addresses: I don't think Pat Thaler can be listed as a front 
> page "author" in the RFC sense unless at least an email address is 
> listed for her. All authors should be pollable about IPR they know and 
> when the draft gets to the AUTH48 state before RFC publication, the 
> RFC editor must be able to contact all the authors. If no email 
> address is known, she should be moved to a "Contributors" section or 
> the like.
Yes. I discovered that (too late) last night, when the draft got 
rejected on this point!
I've added a Contributors section for her.

Thank you again.

Bob

-- 
________________________________________________________________
Bob Briscoe                               http://bobbriscoe.net/

---

From: "Black, David" <[email-masked]>
Date: Tue, 10 Mar 2020 20:14:51 +0000

Writing as draft shepherd …

> Section 4.4, point 1, first starred subpoint, there is something odd about
>     "the packet MAY be forwarded, but it SHOULD be dropped".

>          forwarded.

That’s not much of an improvement.  Here’s the full -13 text to provide the context:

1.  If the arriving inner header is a Not-ECN-PDU it implies the L4
       transport will not understand explicit congestion markings.
       Then:

       *  If the outer header carries an explicit congestion marking,
          drop is the only indication of congestion that the L4
          transport will understand.  If the congestion marking is the
          most severe possible, the packet MUST be dropped.  However, if
          congestion can be marked with multiple levels severity and the
          packet's marking is not the most severe, the packet MAY be
          forwarded, but it SHOULD be dropped.

Assuming that we don’t tinker with the technical content of the last sentence, the better thing to
do with a statement of a “SHOULD” requirement is to explain what may happen if something else
is done.   I  think it’s implicit that a packet that is not dropped gets forwarded instead, so here’s
a suggestion for better text:

          can be relaxed to: the packet SHOULD be dropped, as forwarding

          all such packets may conceal the network congestion that they

          from the L4 transport that does not understand explicit congestion

          markings.

Thanks, --David

From: tsvwg <[email-masked]> On Behalf Of Bob Briscoe
Sent: Tuesday, March 10, 2020 1:29 PM
To: Donald Eastlake; [email-masked]
Cc: John Kaippallimalil
Subject: Re: [tsvwg] Comments on draft-ietf-tsvwg-ecn-encap-guidelines-13

[EXTERNAL EMAIL]
Donald,

I'm not subscribed to the tsvwg mailing list but I have reviewed draft-ietf-tsvwg-ecn-encap-guidelines-13 and though you might be interested in my comments.

Overall, this is a very clear and well-written draft. The comments below are minor. Whether or not they are incorporated into the draft, I hope that it can be advanced soon.

Section 1. I suggest just deleting the one occurrence in the draft of "[RFC1323]" and the corresponding reference section entry. It seems unnecessary and just leads to a nits checker warning which will have to be explained, etc.

Section 1.1. Very minor but I believe the usual way, inside a draft, to refer to the RFC which that draft might become is "[this document]" (without the double quotes) rather than "[RFCXXXX]". Changing to the more common notation would, I believe, enable the RFC Editor note to be removed as "[this document]" is well understood by the RFC Editor.

Section 2. The initial paragraph on implementation keywords should be updated to the following as per RFC 8174:
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT",
"SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this
document are to be interpreted as described in [RFC2119] [RFC8174]
when, and only when, they appear in all capitals, as shown here.
Done all the above
(BTW, I always baulk at having to cite RFC8174, when the following 12 words succinctly state the sum total of its content.)

Section 2. Suggest putting the Terminology entries in alphabetic order..
I haven't done this. They are more for reading through than for being looked up individually, most of them fall into logical little groups, and there are not so many that it's hard to find one.

Section 4.2, page 18. "802.1p" has been merged into 802.1Q ages ago. Values of the priority field are commonly referred to in IEEE 802.1 as Priority Code Points (PCPs) and in any case this seems a bit inconsistent to the way that the merger of 802.1ah into 802.1Q is recognized in the draft. Perhaps the last sentence of Section 4.2 could be: "An operator can define certain [IEEE802.1Q] Priority Code Points to indicate non-QCN frames and an ingress bridge is required to map arriving not-QCN-capable IP packets to one of these code points."
OK. I've taken on board the spirit of your edit, but changed it slightly:

   arriving not-QCN-capable IP packets to one of these non-QCN PCPs.
This is then consistent with the other references to 802.1Q, which also give the number of the constituent part before it was wrapped up into the mega-standard. If you think this is clumsy, pls say. I did it this way, because many people know these 802.1 drafts much better by their old name (well, for 'many people' read 'me', or perhaps read it as 'old farts like me').

Section 4.4, point 1, first starred subpoint, there is something odd about "the packet MAY be forwarded, but it SHOULD be dropped".
Any better (I've added some of the context for the list)?:

          forwarded.

Section 7. It doesn't matter much but IANA would prefer that sections saying there are no IANA actions be left in the final RFC (see Section 9.1 of RFC 8126).
I'm learning something new every day.

Section 9. Should "the document" in the first line of this section by "this document"?
Yes. Done.

Authors' Addresses: I don't think Pat Thaler can be listed as a front page "author" in the RFC sense unless at least an email address is listed for her. All authors should be pollable about IPR they know and when the draft gets to the AUTH48 state before RFC publication, the RFC editor must be able to contact all the authors. If no email address is known, she should be moved to a "Contributors" section or the like.
Yes. I discovered that (too late) last night, when the draft got rejected on this point!
I've added a Contributors section for her.

Thank you again.

Bob

--

---

From: "Black, David" <[email-masked]>
Date: Tue, 10 Mar 2020 21:46:45 +0000

Oops, missing word – new text should be:

          indicate from the L4 transport that does not understand explicit

          congestion markings.

Thanks, --David

From: Black, David <[email-masked]>
Sent: Tuesday, March 10, 2020 4:15 PM
To: Bob Briscoe; Donald Eastlake; [email-masked]
Cc: John Kaippallimalil; Black, David
Subject: RE: [tsvwg] Comments on draft-ietf-tsvwg-ecn-encap-guidelines-13

          markings.

Thanks, --David

From: tsvwg <[email-masked]<mailto:[email-masked]>> On Behalf Of Bob Briscoe
Sent: Tuesday, March 10, 2020 1:29 PM
To: Donald Eastlake; [email-masked]<mailto:[email-masked]>
Cc: John Kaippallimalil
Subject: Re: [tsvwg] Comments on draft-ietf-tsvwg-ecn-encap-guidelines-13

[EXTERNAL EMAIL]
Donald,

          forwarded.

Thank you again.

Bob

--

---

From: Bob Briscoe <[email-masked]>
Date: Wed, 11 Mar 2020 00:48:46 +0000

David,

On 10/03/2020 20:14, Black, David wrote:
> about
I see your point now (and I now see Donald's).
Nonetheless, I'd rather just end the sentence at "...SHOULD be dropped".

The possibility the L4 transport won't understand is given as the 
opening reason for the whole paragraph anyway. Repeating it here, makes 
it look like it's the reason for demoting this low severity case from 
MUST to SHOULD, which is not the intention.

Think SCE - it might not matter whether the L4 transport understands the 
lower severity marking or not.
(I had similar schemes in mind when I added in this text about severity 
levels in 2016).

Bob

> Thanks, --David
>
> *From:*tsvwg <[email-masked]> *On Behalf Of *Bob Briscoe
> *Sent:* Tuesday, March 10, 2020 1:29 PM
> *To:* Donald Eastlake; [email-masked]
> *Cc:* John Kaippallimalil
> *Subject:* Re: [tsvwg] Comments on 
> draft-ietf-tsvwg-ecn-encap-guidelines-13
>
> [EXTERNAL EMAIL]
>
> Donald,
>
>     below are minor. Whether or not they are incorporated into the
>     draft, I hope that it can be advanced soon.
>
>     Section 1. I suggest just deleting the one occurrence in the draft
>     of "[RFC1323]" and the corresponding reference section entry. It
>     seems unnecessary and just leads to a nits checker warning which
>     will have to be explained, etc.
>
>
>     Section 1.1. Very minor but I believe the usual way, inside a
>     draft, to refer to the RFC which that draft might become is "[this
>     document]" (without the double quotes) rather than "[RFCXXXX]".
>     Changing to the more common notation would, I believe, enable the
>     RFC Editor note to be removed as "[this document]" is well
>     understood by the RFC Editor.
>
>
>     Section 2. The initial paragraph on implementation keywords should
>     be updated to the following as per RFC 8174:
>
>     Section 4.2, page 18. "802.1p" has been merged into 802.1Q ages
>     ago. Values of the priority field are commonly referred to in IEEE
>     802.1 as Priority Code Points (PCPs) and in any case this seems a
>     bit inconsistent to the way that the merger of 802.1ah into 802.1Q
>     is recognized in the draft. Perhaps the last sentence of Section
>     4.2 could be: "An operator can define certain [IEEE802.1Q]
>     Priority Code Points to indicate non-QCN frames and an ingress
>     bridge is required to map arriving not-QCN-capable IP packets to
>     one of these code points."
>
> This is then consistent with the other references to 802.1Q, which 
> also give the number of the constituent part before it was wrapped up 
> into the mega-standard. If you think this is clumsy, pls say. I did it 
> this way, because many people know these 802.1 drafts much better by 
> their old name (well, for 'many people' read 'me', or perhaps read it 
> as 'old farts like me').
>
>
>     Section 4.4, point 1, first starred subpoint, there is something
>     odd about "the packet MAY be forwarded, but it SHOULD be dropped".
>
>     Section 7. It doesn't matter much but IANA would prefer that
>     sections saying there are no IANA actions be left in the final RFC
>     (see Section 9.1 of RFC 8126).
>
>     Authors' Addresses: I don't think Pat Thaler can be listed as a
>     front page "author" in the RFC sense unless at least an email
>     address is listed for her. All authors should be pollable about
>     IPR they know and when the draft gets to the AUTH48 state before
>     RFC publication, the RFC editor must be able to contact all the
>     authors. If no email address is known, she should be moved to a
>     "Contributors" section or the like.
>
> Bob Briscoehttp://bobbriscoe.net/

---

From: Donald Eastlake <[email-masked]>
Date: Tue, 10 Mar 2020 21:33:19 -0400

Hi Bob,

> (BTW, I always baulk at having to cite RFC8174, when the following 12 words succinctly state the sum total of its content.)

Thanks. I understand how you feel but currently the IESG likes the
boilerplate with RFC 8174 reference...

> I haven't done this. They are more for reading through than for being looked up individually, most of them fall into logical little groups, and there are not so many that it's hard to find one.

OK.

> This is then consistent with the other references to 802.1Q, which also give the number of the constituent part before it was wrapped up into the mega-standard. If you think this is clumsy, pls say…

I'm fine with your wording. No problem mentioning 802.1p as long as it
doesn't send people off looking for a current version of that but
rather makes it clear that the relevant material in now in 802.1Q.

>           can be relaxed to: the packet SHOULD be dropped, but it MAY be

As per subsequent discussion in this thread, if you are OK with
stopping at "... the packet SHOULD be dropped." that would certainly
resolve my comment.

> I've added a Contributors section for her.

OK, all seems good.

Thanks,
Donald
===============================
 Donald E. Eastlake 3rd   +1-508-333-2270 (cell)
 2386 Panoramic Circle, Apopka, FL 32703 USA
 [email-masked]

---

From: Bob Briscoe <[email-masked]>
Date: Wed, 11 Mar 2020 09:37:47 +0000

Donald,

Thanks - all in my local copy, which will hopefully be uploaded shortly, 
depending on the other discussion about fragmentation.
I'll point you at that, given you're not subscribed to the list.

Bob

---

From: "Black, David" <[email-masked]>
Date: Wed, 11 Mar 2020 15:58:41 +0000

Thanks, --David

> -----Original Message-----
> Sent: Wednesday, March 11, 2020 5:38 AM
> To: Donald Eastlake
> Cc: John Kaippallimalil; [email-masked]
> >> I'm not subscribed to the tsvwg mailing list but I have reviewed draft-ietf-
> tsvwg-ecn-encap-guidelines-13 and though you might be interested in my
> comments.
> >>
> >> Overall, this is a very clear and well-written draft. The comments below are
> minor. Whether or not they are incorporated into the draft, I hope that it can
> be advanced soon.
> >>
> unnecessary and just leads to a nits checker warning which will have to be
> explained, etc.
> >>
> >> Section 1.1. Very minor but I believe the usual way, inside a draft, to refer to
> the RFC which that draft might become is "[this document]" (without the double
> quotes) rather than "[RFCXXXX]". Changing to the more common notation
> would, I believe, enable the RFC Editor note to be removed as "[this document]"
> is well understood by the RFC Editor.
> >>
> >> I haven't done this. They are more for reading through than for being looked
> up individually, most of them fall into logical little groups, and there are not so
> many that it's hard to find one.
> > OK.
> >
> Values of the priority field are commonly referred to in IEEE 802.1 as Priority
> Code Points (PCPs) and in any case this seems a bit inconsistent to the way that
> the merger of 802.1ah into 802.1Q is recognized in the draft. Perhaps the last
> sentence of Section 4.2 could be: "An operator can define certain [IEEE802.1Q]
> Priority Code Points to indicate non-QCN frames and an ingress bridge is
> required to map arriving not-QCN-capable IP packets to one of these code
> points."
> >>
> >> This is then consistent with the other references to 802.1Q, which also give
> the number of the constituent part before it was wrapped up into the mega-
> standard. If you think this is clumsy, pls say. I did it this way, because many
> people know these 802.1 drafts much better by their old name (well, for 'many
> people' read 'me', or perhaps read it as 'old farts like me').
> >> Section 4.4, point 1, first starred subpoint, there is something odd about "the
> packet MAY be forwarded, but it SHOULD be dropped".
> >>
> >> Section 7. It doesn't matter much but IANA would prefer that sections saying
> there are no IANA actions be left in the final RFC (see Section 9.1 of RFC 8126).
> >>
> >> Authors' Addresses: I don't think Pat Thaler can be listed as a front page
> "author" in the RFC sense unless at least an email address is listed for her. All
> authors should be pollable about IPR they know and when the draft gets to the
> AUTH48 state before RFC publication, the RFC editor must be able to contact all
> the authors. If no email address is known, she should be moved to a